% griewank function
% minimum = 0;  X = [0...0]

function Y = flip_griewank(X)
% Y is a column vector, X is a matrix, each row of X is a sample

dim = size(X,2);  % dimension of the problem, i.e., length of each sample

Y=1/4000*sum((X(:,1:dim)).^2, 2)- prod(cos(X(:,1:dim)./sqrt(repmat([1:1:dim],size(X,1),1))),2)+1;

% the above part of the griewank function was intended for a minization problem,
% since GASS is working under a maximization formulation, we need to flip it
Y = -Y;